#include <cstdio>
const int MXN = 100003;
int n, m;
int next[MXN], prev[MXN];
int exist[MXN];
void insert (int x, int y) {
	next[y] = next[x];
	prev[y] = x;
	next[x] = y;
	prev[next[y]] = y;
}
void remove (int x) {
	if (exist[x]) {
		next[prev[x]] = next[x];
		prev[next[x]] = prev[x];
		exist[x] = 0;
	}
}
void print () {
	int x = 0;
	while (1) {
		if (x != 0) printf (" ");
		x = next[x];
		if (x == n + 1)
			break;
		printf ("%d", x);
	}
	printf ("\n");
}
int main () {
	freopen ("1.in", "r", stdin);
	freopen ("1.out", "w", stdout);
	scanf ("%d", &n);
	next[0] = n + 1;
	prev[n + 1] = 0;
	insert (0, 1);
	exist[1] = 1;
	for (int i = 2; i <= n; i ++) {
		int x, p;
		scanf ("%d%d", &x, &p);
		if (!p)
			x = prev[x];
		insert (x, i);
		exist[i]= 1;
	}
	scanf ("%d", &m);
	for (int i = 0; i < m; i++) {
		int x;
		scanf ("%d", &x);
		remove (x);
	}
	print ();
	return 0;
}
